import itertools, time, basis_finder, string

def removeFuels(crn, fuel):
    crn = [[filter(lambda s: s not in fuel, rxn[0]),
            filter(lambda s: s not in fuel, rxn[1])]
           for rxn in crn]
    return crn

def removeWastes(crn, formal):
    species = findSpecies(crn)
    nonwastes = set(formal)
    while True:
        flag = False
        for x in species:
            if x not in nonwastes:
                for rxn in crn:
                    if x in rxn[0] and \
                      (len(nonwastes & set(rxn[1])) > 0 \
                      or len(nonwastes & set(rxn[0])) > 0):
                        flag = True
                        nonwastes.add(x)
                        break
        if not flag: break

    for rxn in crn:
        rxn[0] = filter(lambda s: s in nonwastes, rxn[0])
        rxn[1] = filter(lambda s: s in nonwastes, rxn[1])

    crn = filter(lambda rxn: len(rxn[0]) > 0 or len(rxn[1]) > 0, crn)
    return crn

def findSpecies(crn):
    species = set()
    for rxn in crn:
        for x in rxn[0]:
            species.add(x)
        for x in rxn[1]:
            species.add(x)
    return species

def printRxn(rxn):
    first = True
    for x in rxn[0]:
        if x[0] not in string.letters:
            x = "i" + x
        if not first:
            print "+",
        else:
            first = False
        print x,
    print "->",
    first = True
    for x in rxn[1]:
        if x[0] not in string.letters:
            x = "i" + x
        if not first:
            print "+",
        else:
            first = False
        print x,
    print

def remove_duplicates(l):
    r = []
    if len(l) == 0: return []
    l.sort()
    while len(l) > 1:
        if l[0] != l[1]:
            r.append(l[0])
        l = l[1:]
    r.append(l[0])
    return r

def test(c1, c2, verbose = True):
    (crn1, fs1, cs1) = c1
    (crn2, fs2, cs2) = c2
    #for rxn in crn2:
    #    print rxn
    #print "------"
    crn2 = removeFuels(crn2, cs2)
    crn2 = removeWastes(crn2, fs2)
    crn1 = [[sorted(rxn[0]), sorted(rxn[1])] for rxn in crn1]
    crn2 = [[sorted(rxn[0]), sorted(rxn[1])] for rxn in crn2]
    crn2.sort()
    crn2 = remove_duplicates(crn2)

    # remove trivial reactions
    remove_target = []
    for [R, P] in crn2:
        R.sort()
        P.sort()
        if R == P:
            remove_target.append([R, P])
    for r in remove_target:
        crn2.remove(r)

    crn1size = len(crn1)
    crn2size = len(crn2)
    t1 = time.time()
    print "CRN 1 size :", crn1size
    print "CRN 2 size :", crn2size
    
    # remove duplicates
    crn2.sort()
    i = 0
    while i + 1 < len(crn2):
        if crn2[i] == crn2[i+1]:
            del crn2[i]
        else:
            i += 1

    print "Original CRN:"
    for rxn in crn1:
        print "   ",
        printRxn(rxn)
    print
    print "Compiled CRN:"
    for rxn in crn2:
        print "   ",
        printRxn(rxn)
    print

    basis = basis_finder.find_basis(crn2, fs2)
    for i in range(len(basis)):
        basis[i][0].sort()
        basis[i][1].sort()

    print "Basis of the compiled CRN:"
    for rxn in basis:
        print "   ",
        printRxn(rxn)
    print
    flag = True
    for rxn in crn1:
        if rxn not in basis:
            reactants = {}
            for x in rxn[0]:
                if x in reactants.keys():
                    reactants[x] += 1
                else:
                    reactants[x] = 1
            products = {}
            for x in rxn[1]:
                if x in products.keys():
                    products[x] += 1
                else:
                    products[x] = 1
            if reactants != products:
                print "Error : The formal pathway"
                print "    ",
                printRxn(rxn)
                print " is in the input CRN but not in the compiled CRN."
                flag = False
    for rxn in basis:
        if rxn not in crn1:
            reactants = {}
            for x in rxn[0]:
                if x in reactants.keys():
                    reactants[x] += 1
                else:
                    reactants[x] = 1
            products = {}
            for x in rxn[1]:
                if x in products.keys():
                    products[x] += 1
                else:
                    products[x] = 1
            if reactants != products:
                print "Error : The formal pathway"
                print "    ",
                printRxn(rxn)
                print " is in the compiled CRN but not in the input CRN."
                flag = False

    t2 = time.time()
    print "Elapsed time :", t2-t1
    return flag
